'''
    LOCALMIN

    Assume a function f(x) is defined on all integers.

    Write a decorator function localmin(d) that, for d >= 0, decorates a
    function f such that f(n) returns the minimum of the original 2*d + 1 
    function values:

       f(n-d), ..., f(n-1), f(n), f(n+1), ..., f(n+d)
    
    Input:  Multiple lines of Python code using the decorator localmin.
            The last line starts with '#eof' (indicating end of file).

    Output: The output generated by executing the input code.

    Example:

      Input:  @localmin(2)
              def f(n):
                  return (n - 4) ** 2

              for x in range(10):
                  print(x, f(x))

              #eof

      Output: 0 4
              1 1
              2 0
              3 0
              4 0
              5 0
              6 0
              7 1
              8 4
              9 9
    
    Note: The below code already handles reading and executing the input.
'''


# insert code
pass
#> solution
def localmin(d):
#< solution
#> validate arguments
    assert isinstance(d, int)
    assert d >= 0
#< validate arguments
#> solution
    def decorator(f):
        def wrapper(n):
            return min(f(n_) for n_ in range(n - d, n + d + 1))
        return wrapper
    return decorator
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)